import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import React, { Component } from 'react';
import { getCityState, getState, getBuilding, getBuildingStreetType, getBuildingStreetName, getBuildingArea } from './api';
import Select from 'react-select';
import './Home.css';
import { Container, Form, Button, Col } from 'react-bootstrap';
export var AddressFilterMDU = /*#__PURE__*/function (_Component) {
  _inherits(AddressFilterMDU, _Component);

  var _super = _createSuper(AddressFilterMDU);

  function AddressFilterMDU() {
    var _this;

    _classCallCheck(this, AddressFilterMDU);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      CityState: [],
      StateData: [],
      StreetTypeData: [],
      StreetNameData: [],
      BuildingData: [],
      AreaData: [],
      poscode: '',
      city: '',
      State: '',
      StreetType: '',
      StreetName: '',
      Area: '',
      Building: ''
    };

    _this.componentDidMount = function () {
      _this.setState({
        poscode: _this.props.code
      });

      getCityState(_this.props.code).then(function (res) {
        _this.setState({
          CityState: res
        });
      });
      getBuilding(_this.props.code).then(function (res) {
        _this.setState({
          BuildingData: res
        });
      });
    };

    _this.onChangePostcode = function (e) {
      _this.setState({
        city: '',
        State: '',
        StreetType: '',
        StreetName: '',
        Area: '',
        BuildingName: '',
        poscode: e.target.value,
        CityState: [],
        StateData: [],
        StreetTypeData: [],
        StreetNameData: [],
        BuildingData: [],
        AreaData: []
      });

      getCityState(e.target.value).then(function (res) {
        _this.setState({
          CityState: res
        });
      });
      getBuilding(e.target.value).then(function (res) {
        _this.setState({
          BuildingData: res
        });
      });
    };

    _this.onChangeCity = function (city) {
      if (city == null) city = '';

      _this.setState({
        city: city,
        StateData: [],
        State: ''
      });

      getState(_this.state.poscode, city.value).then(function (res) {
        _this.setState({
          StateData: res
        });
      });
    };

    _this.onChangeState = function (State) {
      _this.setState({
        State: State
      });
    };

    _this.onChangeBuildingName = function (BuildingName) {
      if (BuildingName == null) BuildingName = '';

      _this.setState({
        BuildingName: BuildingName,
        StreetType: '',
        StreetName: '',
        Area: '',
        StreetTypeData: [],
        StreetNameData: [],
        AreaData: []
      });

      getBuildingStreetType(BuildingName.value).then(function (res) {
        _this.setState({
          StreetTypeData: res
        });
      });
    };

    _this.onChangeStreetType = function (StreetType) {
      if (StreetType == null) StreetType = '';

      _this.setState({
        StreetType: StreetType,
        StreetName: '',
        Area: '',
        AreaData: []
      });

      getBuildingStreetName(_this.state.BuildingName.value, StreetType.value).then(function (res) {
        _this.setState({
          StreetNameData: res
        });
      });
    };

    _this.onChangeStreetName = function (StreetName) {
      if (StreetName == null) StreetName = '';

      _this.setState({
        StreetName: StreetName
      }); //this.setState({ Area: '' });
      //this.setState({ AreaData: [] });


      getBuildingArea(_this.state.BuildingName.value, _this.state.StreetType.value, StreetName.value).then(function (res) {
        _this.setState({
          AreaData: res
        });
      });
    };

    _this.onChangeArea = function (Area) {
      _this.setState({
        Area: Area
      });
    };

    _this.getData = function (obj, field) {
      var tmplist = [];

      for (var i in obj) {
        tmplist.push(obj[i][field]);
      }

      ;

      var unique = _toConsumableArray(new Set(tmplist));

      var filterArr = [];

      for (var _i in unique) {
        filterArr.push({
          value: unique[_i],
          label: unique[_i]
        });
      }

      ;
      return filterArr;
    };

    return _this;
  }

  _createClass(AddressFilterMDU, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return /*#__PURE__*/React.createElement(Container, null, /*#__PURE__*/React.createElement(Button, {
        variant: "outline-dark",
        size: "lg",
        block: true
      }, "Condo/ Apartment/ Flat/ Shophouse"), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "UUUU"
      }, /*#__PURE__*/React.createElement(Form.Label, null))), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "postcode"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "Postcode"), /*#__PURE__*/React.createElement("input", {
        type: "number",
        id: "postcode",
        name: "postcode",
        value: this.state.poscode,
        onChange: function onChange(e) {
          return _this2.onChangePostcode(e);
        },
        placeholder: "Type address postcode here...",
        className: "form-control"
      })), /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "BuildingName"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "Building Name"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.BuildingName,
        onChange: this.onChangeBuildingName,
        options: this.getData(this.state.BuildingData, "building_name"),
        isClearable: false,
        id: "BuildingName"
      }))), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "HouseNo"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "Block-Floor-Unit"), /*#__PURE__*/React.createElement("input", {
        id: "HouseNo",
        name: "HouseNo",
        className: "form-control"
      }))), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "STType"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "StreetType"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.StreetType,
        onChange: this.onChangeStreetType,
        options: this.getData(this.state.StreetTypeData, "street_type"),
        isClearable: false,
        id: "street_type"
      })), /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "STName"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "StreetName"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.StreetName,
        onChange: this.onChangeStreetName,
        options: this.getData(this.state.StreetNameData, "street_name"),
        isClearable: false,
        id: "street_name"
      }))), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "Area"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "Area/Section"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.Area,
        onChange: this.onChangeArea,
        options: this.getData(this.state.AreaData, "area"),
        isClearable: false,
        id: "area"
      }))), /*#__PURE__*/React.createElement(Form.Row, null, /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "City"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "City"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.city,
        onChange: this.onChangeCity,
        options: this.getData(this.state.CityState, "city"),
        isClearable: false,
        id: "city"
      })), /*#__PURE__*/React.createElement(Form.Group, {
        as: Col,
        controlId: "State"
      }, /*#__PURE__*/React.createElement(Form.Label, null, "State"), /*#__PURE__*/React.createElement(Select, {
        value: this.state.State,
        onChange: this.onChangeState,
        options: this.getData(this.state.StateData, "state"),
        isClearable: true,
        id: "state"
      }))));
    }
  }]);

  return AddressFilterMDU;
}(Component);
export default AddressFilterMDU;